#!/usr/bin/perl
#
# $Id: bulkwalk.pl,v 5.0 2002/04/20 07:30:18 hardaker Exp $
#

use SNMP;

my $hostname	= shift;
my $community	= shift;
my $qry		= shift;
my $arg		= shift;
my $bytidx	= shift;

$SNMP::debugging = 0;
$SNMP::dump_packet = 0;

$sess = new SNMP::Session( 'DestHost'	=> $hostname,
			   'Community'	=> $community,
			   'RemotePort'	=> 161,
			   'Timeout'	=> 300000,
			   'Retries'	=> 3,
			   'Version'	=> '2c',
			   'UseLongNames' => 1,	   # Return full OID tags
			   'UseNumeric' => 1,	   # Return dotted decimal OID
			   'UseEnums'	=> 0,	   # Don't use enumerated vals
			   'UseSprintValue' => 0); # Don't pretty-print values

if ($qry eq "query") {
if ($arg eq "index") {
	indices();
exit;
}
elsif ($arg eq "class") {
	classes();
exit;
}
elsif ($arg eq "alias") {
	aliases();
exit;
}
elsif ($arg eq "byte") {
	bytes($bytidx);
exit;
}
elsif ($arg eq "drop") {
	drops($bytidx);
exit;
}
exit;
}




sub indices {

my $varsIfIndex = new SNMP::VarList(['1.3.6.1.4.1.9.9.166.1.1.1.1.4']);

@respIfIndex = $sess->bulkwalk(0, 50, $varsIfIndex);
die "Cannot do bulkwalk: $sess->{ErrorStr} ($sess->{ErrorNum})\n"
							if $sess->{ErrorNum};

for $vbarr ( @respIfIndex ) {
    $oidIfIndex = $$varsIfIndex[$i++]->tag();

    for $v (@$vbarr) {
	my $QoSOID 	= $v->name;
	my @QoSOID_chop = split /\./, $QoSOID;
	print $QoSOID_chop[15],":",$QoSOID_chop[15],"\n";
    }
}
}




sub classes {

my $varsCMName = new SNMP::VarList(['1.3.6.1.4.1.9.9.166.1.7.1.1.1']);
$i=0;

@respCMName = $sess->bulkwalk(0, 50, $varsCMName);

for $vbarr ( @respCMName ) {
    $oid = $$varsCMName[$i++]->tag();
	
    for $v (@$vbarr) {
	my $QoSOID      = $v->name;
	my @QoSOID_chop = split /\./, $QoSOID;
	print $QoSOID_chop[15], ":", $v->val, "\n";
    }
}
}


sub aliases {

my $varsIfIndex = new SNMP::VarList(['1.3.6.1.4.1.9.9.166.1.1.1.1.4']);
$i=0;

@respIfIndex = $sess->bulkwalk(0, 50, $varsIfIndex);
die "Cannot do bulkwalk: $sess->{ErrorStr} ($sess->{ErrorNum})\n"
                                                        if $sess->{ErrorNum};

for $vbarr ( @respIfIndex ) {
    $oidIfIndex = $$varsIfIndex[$i++]->tag();

    for $v (@$vbarr) {
	my $IfIdx = $v->val;
	my $IfIdxsum = "1.3.6.1.2.1.31.1.1.1.18.$IfIdx";
	my $alias = $sess->get($IfIdxsum);
        my $QoSOID      = $v->name;
        my @QoSOID_chop = split /\./, $QoSOID;
	print $QoSOID_chop[15],":",$alias, "\n";
    }
}
}

sub bytes {

my $cbQosCMPrePolicyByte64      = "1.3.6.1.4.1.9.9.166.1.15.1.1.6.";
my $tmp				= shift;
my $varsPPByte 			= new SNMP::VarList["$cbQosCMPrePolicyByte64$tmp"];
$i=0;

@respPPByte = $sess->bulkwalk(0, 50, $varsPPByte);
die "Cannot do bulkwalk: $sess->{ErrorStr} ($sess->{ErrorNum})\n"
							if $sess->{ErrorNum};
for $vbarr ( @respPPByte ) {
	$oidPPByte = $$varsPPByte[$i++]->tag();
	for $v (@$vbarr) {
	my $QoSOID 		= $v->name;
	my @QoSOID_chop 	= split /\./, $QoSOID;
	my $QoScfgidxOID	= "1.3.6.1.4.1.9.9.166.1.5.1.1.2.$QoSOID_chop[15].$QoSOID_chop[16]";
	my $QoScfgidx		=  $sess->get($QoScfgidxOID);
	print $QoScfgidx, ":",$v->val, " ";
    	}
	print "\n";
}
}

sub drops {

my $cbQosCMDropPkt		= "1.3.6.1.4.1.9.9.166.1.15.1.1.13.";
my $tmp				= shift;
my $varsDrop 			= new SNMP::VarList["$cbQosCMDropPkt$tmp"];
$i=0;

@respDrop = $sess->bulkwalk(0, 50, $varsDrop);
die "Cannot do bulkwalk: $sess->{ErrorStr} ($sess->{ErrorNum})\n"
							if $sess->{ErrorNum};
for $vbarr ( @respDrop ) {
	$oidDrop = $$varsDrop[$i++]->tag();
	for $v (@$vbarr) {
	my $QoSOID 		= $v->name;
	my @QoSOID_chop 	= split /\./, $QoSOID;
	my $QoScfgidxOID	= "1.3.6.1.4.1.9.9.166.1.5.1.1.2.$QoSOID_chop[15].$QoSOID_chop[16]";
	my $QoScfgidx		=  $sess->get($QoScfgidxOID);
	print $QoScfgidx, ":",$v->val, " ";
    	}
	print "\n";
}
}

exit 0;